libname imp 'I:\lqn\Improve';

*list all sites;
proc freq data=imp.annual_means_postsort; tables site; run;

options mprint mlogic symbolgen;
%MACRO TPOSE(NAME);
%****************************** PERFORM TRANSPOSE;
data two;
	 keep region year site _name_;
	 set imp.annual_means_postsort;
	 if year ge 1992;
	 if site in ('DENA') then delete;
	 if site in('ACAD','SHEN','GRSM','BRIG','CHAS','DOSO','LYBR','MACA','OKEF','UPBU') then region='EAST';
	 	else if site in ('WASH') then region='WASH';
	 		else region='WEST';
	 _name_=&name;
	 
*TRANSPOSE AND INTERPOLATE FOR TWO - SITES WITH 10 YEARS;
PROC SORT DATA=TWO;
     BY REGION site;
PROC TRANSPOSE DATA=TWO OUT=D2&NAME PREFIX=&NAME;
     BY REGION site;
     VAR _NAME_;
DATA FIXTWO;
     SET D2&NAME;
*need 8 out of the 10 years;
     minyrs=8;
	 nyrs=n(of &name.1-&name.10);
	 if nyrs lt minyrs then delete;
*INTERPOLATE TO FILL IN FOR MISSING SITE YEARS;
ARRAY YEAR(10) &NAME.1-&NAME.10;
    IF YEAR(1) EQ . AND YEAR(2) NE . THEN YEAR(1)=YEAR(2);
    IF YEAR(1) EQ . AND YEAR(2) EQ . THEN DO;
       YEAR(1) = YEAR(3);
       YEAR(2) = YEAR(3);
    END;
    IF YEAR(10) EQ . AND YEAR(9) NE . THEN YEAR(10)=YEAR(9);
    IF YEAR(10) EQ . AND YEAR(9) EQ . THEN DO;
       YEAR(10) = YEAR(8);
       YEAR(9)  = YEAR(8);
    END;
DO I=2 TO 9;
   IF YEAR(I) EQ . AND YEAR(I+1) NE . THEN
      YEAR(I) = YEAR(I-1)+(YEAR(I+1)-YEAR(I-1))/2;
   IF YEAR(I) EQ . AND YEAR(I+1) EQ . THEN
      YEAR(I) = YEAR(I-1)+(YEAR(I+2)-YEAR(I-1))/3;
END;

DATA COMBINE;
     DROP _NAME_;
     SET FIXTWO;
     LABEL &NAME.1 = "&NAME.1992"
           &NAME.2 = "&NAME.1993"
           &NAME.3 = "&NAME.1994"
           &NAME.4 = "&NAME.1995"
           &NAME.5 = "&NAME.1996"
           &NAME.6 = "&NAME.1997"
           &NAME.7 = "&NAME.1998"
           &NAME.8 = "&NAME.1999"
           &NAME.9 = "&NAME.2000"
		   &NAME.10 = "&NAME.2001";
PROC SORT;
     BY REGION site;
PROC PRINT U;
TITLE  "&NAME AT IMPROVE SITES, 1992-2001";

proc sort; by region;
proc univariate noprint;
	 by region;
	 var &name.1-&name.10;
	 output out=summary mean=mean&name.1-mean&name.10 n=nsites&name.1-nsites&name.10;
proc print u; run;

PROC EXPORT DATA= WORK.SUMMARY 
            OUTFILE= "I:\lqn\Improve\summary&name&sysdate..xls" 
            DBMS=EXCEL2000 REPLACE;
RUN;

%************************** END OF TRANSPOSE;
%MEND TPOSE;

* CALL MACRO TO TRANSPOSE DATA SET;

%TPOSE(ammsul) run;
%TPOSE(ammnit) run;
%TPOSE(omc) run;
%TPOSE(lac) run;
%TPOSE(soil) run;
%TPOSE(fmass) run;
%TPOSE(cm) run;

proc freq data=two; by region; tables site; run;